import { UnitType } from "cssUnitFunctions";
export declare const parseCalc: (input: string, parserFunction: (input: string) => any) => string;
export declare type Node = MaxNode | MinNode | ClampNode | ParenthesisNode | AdditionNode | MultiplicationNode | ValueNode | VarNode | CalcNode;
export declare type MaxNode = {
    type: "max";
    values: Array<Node>;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type MinNode = {
    type: "min";
    values: Array<Node>;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type ClampNode = {
    type: "clamp";
    min: Node;
    value: Node;
    max: Node;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type ValueNode = {
    type: "value";
    value: number;
    unit: string;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type VarNode = {
    type: "var";
    value: number;
    name: string;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type ParenthesisNode = {
    type: "parenthesis";
    value: Node;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type AdditionNode = {
    type: "addition";
    values: Array<{
        value: Node;
        operation: "+" | "-";
    }>;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type MultiplicationNode = {
    type: "multiplication";
    values: Array<{
        value: Node;
        operation: "*" | "/";
    }>;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
export declare type CalcNode = {
    type: "calc";
    value: Node;
    rangeInfo?: Array<{
        unit: string;
        min: number;
        max: number;
    }>;
    possibleUnits?: Array<UnitType>;
};
